<html lang="en">
<head>
<title>Creating Buttons - Speedbar: File/Tag summarizing utility</title>
<meta http-equiv="Content-Type" content="text/html">
<meta name="description" content="Speedbar: File/Tag summarizing utility">
<meta name="generator" content="makeinfo 4.8">
<link title="Top" rel="start" href="index.html#Top">
<link rel="up" href="Creating-a-display.html#Creating-a-display" title="Creating a display">
<link rel="next" href="Generic-Tag-Lists.html#Generic-Tag-Lists" title="Generic Tag Lists">
<link href="http://www.gnu.org/software/texinfo/" rel="generator-home" title="Texinfo Homepage">
<meta http-equiv="Content-Style-Type" content="text/css">
<style type="text/css"><!--
  pre.display { font-family:inherit }
  pre.format  { font-family:inherit }
  pre.smalldisplay { font-family:inherit; font-size:smaller }
  pre.smallformat  { font-family:inherit; font-size:smaller }
  pre.smallexample { font-size:smaller }
  pre.smalllisp    { font-size:smaller }
  span.sc    { font-variant:small-caps }
  span.roman { font-family:serif; font-weight:normal; } 
  span.sansserif { font-family:sans-serif; font-weight:normal; } 
--></style>
</head>
<body>
<div class="node">
<p>
<a name="Creating-Buttons"></a>
Next:&nbsp;<a rel="next" accesskey="n" href="Generic-Tag-Lists.html#Generic-Tag-Lists">Generic Tag Lists</a>,
Up:&nbsp;<a rel="up" accesskey="u" href="Creating-a-display.html#Creating-a-display">Creating a display</a>
<hr>
</div>

<h4 class="subsection">7.4.1 Creating Speedbar Buttons</h4>

<p>While it is certainly possible to insert your own text and add
decorations to it, it is preferable to use the speedbar button
creation API instead.

<div class="defun">
&mdash; Function: <b>speedbar-insert-button</b><var> text face mouse function &amp;optional token prevline<a name="index-speedbar_002dinsert_002dbutton-84"></a></var><br>
<blockquote><p>This function inserts one button into the current location. 
<var>text</var> is the text to insert.  <var>face</var> is the face in which it
will be displayed.   <var>mouse</var> is the face to display over the text
when the mouse passes over it.  <var>function</var> is called whenever the
user clicks on the text.

        <p>The optional argument <var>token</var> is extra data to associated with the
text.  Lastly <var>prevline</var> should be non-<code>nil</code> if you want this line to
appear directly after the last button which was created instead of on
the next line. 
</p></blockquote></div>

   <p>This routine creates a single button in the display, such as a [+]
button, or the text that goes after it.  It is designed to be called
iteratively with indicators on when to add carriage returns between
buttons.

   <p>To insert a more traditional speedbar line that includes an expansion
button followed by clickable text, it is preferable to create a
tag-line.  Tag lines should be used to represent typical data a user
will interact with.

<div class="defun">
&mdash; Function: <b>speedbar-make-tag-line</b><var> exp-button-type exp-button-char exp-button-function exp-button-data tag-button tag-button-function tag-button-data tag-button-face depth<a name="index-speedbar_002dmake_002dtag_002dline-85"></a></var><br>
<blockquote>
<p>Create a tag line with <var>exp-button-type</var> for the small expansion
button.  This is the button that expands or contracts a node (if
applicable), and <var>exp-button-char</var> the character in it (`<samp><span class="samp">+</span></samp>',
`<samp><span class="samp">-</span></samp>', `<samp><span class="samp">?</span></samp>',
etc).  <var>exp-button-function</var> is the function to call if it's clicked
on.  Button types are <code>'bracket</code>, <code>'angle</code>, <code>'curly</code>,
<code>'expandtag</code>, <code>'statictag</code>, or nil.  <var>exp-button-data</var> is
extra data attached to the text forming the expansion button.

        <p>Next, <var>tag-button</var> is the text of the tag. 
<var>tag-button-function</var> is the function to call if clicked on, and
<var>tag-button-data</var> is the data to attach to the text field (such a
tag positioning, etc).  <var>tag-button-face</var> is a face used for this
type of tag.

        <p>Lastly, <var>depth</var> shows the depth of expansion.

        <p>This function assumes that the cursor is in the speedbar window at the
position to insert a new item, and that the new item will end with a CR. 
</p></blockquote></div>

   <p>Major display modes that use this function will have a consistant look
and feel and reliable image use.

   </body></html>

